/* =====================================================================

   LiMo - Liblary
      Command line switch.  - ޥɥ饤󥹥åɤ߼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Dec.14.1999  Programing start
  Dec.29.1999  -root add
  Mar.24.2000  -help add
  Aug.20.2000  -level add

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRSwitch             -- åϽ
  RRSwitchGetHelp      -- إץåϤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "rr_switch.h"
#include "main.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  help_output(void);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

static  gboolean  help_flag;
static  gint      com_level;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRSwitch            -- åϽ

   return : void
   int argc, char *argv[]

-------------------------------------------------------------- */
void RRSwitch(int argc, char *argv[])
{
  char line[256];
  int rest, i;

  help_flag = FALSE;
  com_level = 0;

  rest = argc - 1;
  i = 1;
  while(rest > 0) {
    /* --- إץå */
    if ((strcmp(argv[i], "-h") == 0) ||
	(strcmp(argv[i], "--help") == 0)) {
      help_output();
      help_flag = TRUE;
    }
    /* --- data  */
    if (((strcmp(argv[i], "-d") == 0) ||
	(strcmp(argv[i], "--data") == 0)) && (rest > 1)) {
      if (game_data_name != NULL) g_free(game_data_name);
      game_data_name = (gchar*) g_malloc(strlen(argv[i+1]) + 1);
      strcpy(game_data_name, argv[i+1]);
      i++;
      rest--;
    }
    /* --- cd device å */
    if (((strcmp(argv[i], "-c") == 0) ||
	(strcmp(argv[i], "--cddevice") == 0)) && (rest > 1)) {
      if (cd_device_name != NULL) g_free(cd_device_name);
      cd_device_name = (gchar*) g_malloc(strlen(argv[i+1]) + 1);
      strcpy(cd_device_name, argv[i+1]);
      i++;
      rest--;
    }
    /* --- ٥å */
    if (((strcmp(argv[i], "-t") == 0) ||
	(strcmp(argv[i], "--think") == 0)) && (rest > 1)) {
      strncpy(line, argv[i+1], 256);
      sscanf(line, "%d", &com_level);
      printf("COM think pattern : %d\n", com_level);
      i++;
      rest--;
    }
    i++;
    rest--;
  }
}


/* -------------------------------------------------------------
  RRSwitchGetHelp  -- helpåɤ߼

   return : gboolean ꤵƤ뤫ɤե饰

-------------------------------------------------------------- */
gboolean RRSwitchGetHelp(void)
{
  return(help_flag);
}


/* -------------------------------------------------------------
  RRSwitchGetLevel  -- helpåɤ߼

   return : gint ԥ塼ζ(0̵)

-------------------------------------------------------------- */
gboolean RRSwitchGetLevel(void)
{
  return(com_level);
}



/* -----------------------------------------------------------------------
 --- ̥å
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  help_output  -- ޥɥإפɽ
-------------------------------------------------------------- */
void  help_output(void) {
  printf("--- Urahara temptation\n");
  printf("usage: lm_uraten [-l|--level  n]\n");
  printf("                 [-h|--help] [-d|--data dataname]\n");
  printf("                 [-c|--cddevice device name]\n");
  printf("\n");
  printf("  think    : COM think pattern.\n");
  printf("  h/help   : print this message.\n");
  printf("  data     : game data.\n");
  printf("  cddevice : CD-ROM device name.\n");
  printf("\n");
}

