/* =====================================================================

   LiMo Reversi 
      Thinking.   - ԥ塼׹ͥ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- Thanks

  Υ롼 MINABE Oki <minabe@kitanet.ne.jp> 
  󶡤ޤ˴դҤ٤ĺޤ
                                                Aug.20.2000

  ޤܡĴѴؿγĥȤ
    RVBoardMiniAbleFast(gint, gint, gint*);
    RVBoardMiniCountAble(gint, gint*, gint*);
    RVBoardMiniReverse(gint, gint, gint*);
    do_reverse_mini(gint, gint, gint, gint*);
  ȤäʻƥޡƤƤޤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- History

  Aug.20.2000  Marge

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <gtk/gtk.h>
#include "rv_board.h"
#include "rv_com.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define THINK_DEPTH 4

#define KADO  1000
#define HAJI   100
#define TONARI   5
#define NORMAL  50
#define ABLE    80
#define PASS 20000

/* ---- ݥɾơ֥ */
const gint score_koma[64] = {
  KADO  , TONARI, HAJI  , HAJI  , HAJI  , HAJI  , TONARI, KADO  ,
  TONARI, TONARI, NORMAL, NORMAL, NORMAL, NORMAL, TONARI, TONARI,
  HAJI  , NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, HAJI  ,
  HAJI  , NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, HAJI  ,
  HAJI  , NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, HAJI  ,
  HAJI  , NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, NORMAL, HAJI  ,
  TONARI, TONARI, NORMAL, NORMAL, NORMAL, NORMAL, TONARI, TONARI,
  KADO  , TONARI, HAJI  , HAJI  , HAJI  , HAJI  , TONARI, KADO
};


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

gint  eval_depth(gint, gint, gint, gint, gint*);
gint  eval(gint, gint*, gint*);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  ai_think003         -- Ūʻ׹ͥ롼

  ƵŪݥɾˡ

-------------------------------------------------------------- */
void  ai_think003(void)
{
  gint  pos;
  gint  board[64];
  gint  i, max, t;

  RVBoardMini(board);
  pos = -1;

  max = INT_MIN;
  for(i=0; i<64; i++) {
    if (board[i] == 0 && RVBoardMiniAbleFast(1, i, board) > 0) {
      t = eval_depth(1, i, THINK_DEPTH, max, board);
      if (t > max) {
	pos = i;
	max = t;
      }
    }
  }

  /* --- ̤֤ */
  RVComReturn(pos);
}


/* -----------------------------------------------------------------------
 --- ֥롼
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  eval_depth

   return : gint(ɾ)
   gint  side, pos, depth, nmax, *board

-------------------------------------------------------------- */
gint  eval_depth(gint side, gint pos, gint depth, gint nmax, gint *board)
{
  gint board_next[64], flag[64];
  gint i, t, max, score;

  for(i=0; i<64; i++) {
    board_next[i] = board[i];
  }
  RVBoardMiniReverse(side, pos, board_next);

  score = eval(side, board_next, flag);

  if (depth > 0 && flag[0] != -1) {
    max = INT_MIN;
    for(i=0; flag[i]!=-1; i++) {
      t = eval_depth(side ^ 3, flag[i], depth - 1, max, board_next);
      if (score - t < nmax) {
	max = t;
	break;
      }
      if (t > max) {
	max = t;
      }
    }
    score -= max;
  }

  return score;
}

/* -------------------------------------------------------------
  eval

   return : gint(ɾ)
   gint  side, *board, *flag

-------------------------------------------------------------- */
gint  eval(gint side, gint *board, gint *flag)
{
  gint i, t, score = 0;

  for(i=0; i<64; i++) {
    if (board[i] == side) {
      score += score_koma[i];
    }
  }

  t = RVBoardMiniCountAble(side ^ 3, board, flag);

  if (t == 0) {
    score += PASS;
  }
  else {
    score -= t * ABLE;
  }

  return score;
}
