#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "rr_main.h"
#include "rr_input.h"
#include "rr_screen.h"
#include "rv_data.h"

void
on_mainwin_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_main_quit();
  RVDataBGMRequest(0);
}


void
on_item1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_gamequit_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_main_quit();
  RVDataBGMRequest(0);
}


void
on_frame1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_f1_5_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainInterval(5);
}


void
on_f1_10_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainInterval(10);
}


void
on_f1_20_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RRMainInterval(20);
}


gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  return(RRScreenRedraw(widget, event, user_data));
}


gboolean
on_drawingarea1_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  return(RRInputSignalPress(widget, event, user_data));
}


void
on_wave_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RVDataBGMDevice(0);
}


void
on_cd_da_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  RVDataBGMDevice(1);
}

