/* =====================================================================

   LiMo Reversi 
      Board Manage.  - $B%2!<%`HW$N4IM}(B

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

#ifndef RV_BOARD

#define RV_BOARD

#ifdef __cplusplus
extern              "C"
{
#endif                          /* __cplusplus */

  /* -------------------------------------------------------------
     --- Struct
   -------------------------------------------------------------- */

  /* -- $B%\!<%I>e$N6p4IM}(B */

typedef struct _RVKoma RVKoma;
struct _RVKoma
{
  gint  stat;                /* $BB0@-(B (0=$B6u$-(B,1=$BGr(B,2=$B@V(B) */
  gint  anim_wait;           /* $B%"%K%a!<%7%g%s3+;O$^$G$N%&%'%$%H(B */
  gint  anim_num;            /* $B%"%K%a!<%7%g%sHV9f(B */
  gint  anim_timer;          /* $B%"%K%a!<%7%g%s%?%$%^!<(B(20$B4pK\(B) */
  gboolean  anim_flag;       /* $B%"%K%a!<%7%g%s%U%i%0(B */
  gboolean  update;          /* $BI=<(99?7%U%i%0(B */
};

  /* -------------------------------------------------------------
     --- Extern
   -------------------------------------------------------------- */
  void       RVBoardInit(void);
  RVKoma*    RVBoardKoma(gint);
  gboolean   RVBoardKomaAnimStat(void);
  void       RVBoardKomaAnim(void);
  gboolean   RVBoardKomaAnimStat(void);
  gboolean   RVBoardCheckPass(gint side);
  gint       RVBoardAbleToPut(gint side, gint pos);
  void       RVBoardPutKoma(gint side, gint pos);
  gint       RVBoardReverseKoma(gint side, gint pos);
  void       RVBoardMini(gint *board);
  gint       RVBoardMiniAble(gint, gint, gint*);
  gint       RVBoardMiniAbleFast(gint, gint, gint*);
  gint       RVBoardMiniCountAble(gint, gint*, gint*);
  gint       RVBoardMiniReverse(gint, gint, gint*);

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif


